program project1;

uses
  Classes, SysUtils;

var
  OBL_mem,RAM_mem, Image: TMemoryStream;
  i,sum:integer;
  b:byte;
  S: string;
const
  N2KDirMark = $9B1EA38D;

FUNCTION ASH (e, bit : INTEGER): INTEGER;
BEGIN
  IF bit < 0 THEN e := e SHR ABS(bit) ELSE e := e SHL bit;
  RESULT:=e;
END;

FUNCTION _MOD (CONST x, y: INTEGER): INTEGER;
BEGIN
  ASSERT(y > 0);
  IF x >= 0 THEN
    RESULT := x MOD y
  ELSE
    RESULT := (y + (x MOD y)) MOD y;
END;

begin
  OBL_mem:= TMemoryStream.Create;
  OBL_mem.LoadFromFile('OBL.Bin');
  OBL_mem.Position:=0;

  RAM_mem:= TMemoryStream.Create;
  RAM_mem.LoadFromFile('ram.bin');
  RAM_mem.Position:=0;

  sum:=0;
  while RAM_mem.Position<RAM_mem.Size do begin
    b:=RAM_mem.ReadByte;
    sum := _MOD((sum + b),$100);
	end;
	sum := _MOD(-sum,$100);
  sum := 1 + ASH(sum,16);
  RAM_mem.Position:=0;

  Image:= TMemoryStream.Create;

  Image.Position:=0;
  for i:=0 to $1000 do Image.WriteByte($FF);
  for i:=$1000 to 1474560-2 do Image.WriteByte($00);

  Image.Position:=0;
  Image.CopyFrom(OBL_mem,OBL_mem.Size);
  Image.Position:=$1000;
  Image.CopyFrom(RAM_mem,RAM_mem.Size);

  while (Image.Position mod 512<>0) do Image.WriteByte($00);
  i:=Image.Position;
  Image.WriteDWord(N2KDirMark);

  Image.Position:=$0A;
  Image.WriteByte($1F);
  Image.Position:=$0B;
  Image.WriteByte($00);

  Image.Position:=$0C;
  Image.WriteByte($02);
  Image.Position:=$0D;
  Image.WriteByte($02);

  Image.Position:=$0E;
  Image.WriteByte($CD);
  Image.Position:=$0F;
  Image.WriteByte($01);

  Image.Position:=$20;
  Image.WriteByte($40);
  Image.Position:=$21;
  Image.WriteByte($0B);

  Image.Position:=$800;
  Image.WriteDWord($07);
  Image.WriteDWord($1C);

  Image.Position:=$808;
  Image.WriteDWord($1000);  //LoadAdr
  Image.WriteDWord(sum);
  Image.WriteDWord($1000);  //StartAdr
  Image.WriteDWord(0);
  Image.WriteDWord((RAM_mem.Size+512-1) div 512);    // Files.Length(f)+BS-1) DIV BS

  Image.WriteDWord($08);
  Image.WriteDWord($8C);

  S:='Init'+#0;
  Image.Write(S[1],Length(S));

  if ParamStr(1)='0' then
    S:='9090'+#0
  else if ParamStr(1)='1' then
    S:='b81200cd10bb003fb80110cd10'+#0
  else if ParamStr(1)='2' then
    S:='b86a00cd10bb003fb80110cd10'+#0+'DWidth'+#0+'800'+#0+'DHeight'+#0+'600'+#0
  else if ParamStr(1)='3' then
    //S:='b8024fbb0341cd10b8014fb90301cd10268b4d28268b552a'+#0+'DWidth'+#0+'800'+#0+'DHeight'+#0+'600'+#0+'DDepth'+#0+'8'+#0
    //S:='b8024fbb1441cd10b8014fb91401cd10268b4d28268b552a'+#0+'DWidth'+#0+'800'+#0+'DHeight'+#0+'600'+#0+'DDepth'+#0+'16'+#0
    // Для BOCHS это 24 бит режим для Virtual PC - 32 бит
    S:='b8024fbb1541cd10b8014fb91501cd10268b4d28268b552a'+#0+'DWidth'+#0+'800'+#0+'DHeight'+#0+'600'+#0+'DDepth'+#0+'32'+#0
    //S:='b8024fbb4341cd10b8014fb94301cd10268b4d28268b552a'+#0+'DWidth'+#0+'800'+#0+'DHeight'+#0+'600'+#0+'DDepth'+#0+'32'+#0
  else if ParamStr(1)='4' then
    S:='bb0301b8024fcd10ba00e0b90000'+#0+'Display'+#0+'SVGA'+#0+
       'DWidth'+#0+'800'+#0+'DHeight'+#0+'600'+#0+
       'SVGA'+#0+'1'+#0
  else
    S:='9090'+#0+'DMode'+#0+'00000143H'+#0;

  Image.Write(S[1],Length(S));

  Image.SaveToFile('O.img');

  OBL_mem.Free;
  RAM_mem.Free;
  Image.Free;

end.

